@echo off
SETLOCAL ENABLEDELAYEDEXPANSION

:: Color Codes
set "GREEN=[92m"
set "YELLOW=[93m"
set "RED=[91m"
set "RESET=[0m"

::::::
echo %GREEN%Am inceput instalarea pentru ComfyUI%RESET% 

set /p installDrive=Tasteaza litera drive-ului unde vrei sa instalezi ComfyUI (ex: C, D, E): 
echo %YELLOW%Ai selectat drive-ul %installDrive%.%RESET%

echo %YELLOW%Descarcare Git...%RESET%
if "%PROCESSOR_ARCHITECTURE%"=="x86" (
    curl -L -o %temp%\git-installer.exe https://github.com/git-for-windows/git/releases/download/v2.43.0.windows.1/Git-2.43.0-32-bit.exe
) else (
    curl -L -o %temp%\git-installer.exe https://github.com/git-for-windows/git/releases/download/v2.43.0.windows.1/Git-2.43.0-64-bit.exe
)
echo %YELLOW%Instalare Git...%RESET%
start /wait %temp%\git-installer.exe /VERYSILENT

echo %YELLOW%Descarcare 7-Zip...%RESET%
if "%PROCESSOR_ARCHITECTURE%"=="x86" (
    curl -L -o %temp%\7zip-installer.exe https://www.7-zip.org/a/7z2301.exe
) else (
    curl -L -o %temp%\7zip-installer.exe https://7-zip.org/a/7z2301-x64.exe
)
echo %YELLOW%Instalare 7-Zip...%RESET%
start /wait %temp%\7zip-installer.exe /S

echo %GREEN%Am instalat Git si 7-Zip.%RESET%

set sevenZipPath=C:\Program Files\7-Zip\7z.exe
if exist "%sevenZipPath%" (
    echo %GREEN%7-Zip este instalat corect..%RESET%
) else (
    echo %RED%7-Zip nu este instalat corect. Te rog instaleaza-l in C:\Program Files\7-Zip\ si apoi ruleaza din nou acest installer.%RESET%
    pause
    exit /b
)

::::
set downloadUrl=https://github.com/comfyanonymous/ComfyUI/releases/latest/download/ComfyUI_windows_portable_nvidia.7z

set outputDir=%installDrive%:
echo %YELLOW%ComfyUI va fi instalat pe drive-ul %outputDir%.%RESET%

if not exist %installDrive%:\ (
    echo "%RED%Ai selectat un drive invalid. Te rog selecteaza un drive care exista la tine pe calculator.(Intotdeauna poti alege drive-ul C)%RESET%"
    pause
    exit /b
)

echo %YELLOW%Am inceput sa instalez ComfyUI%RESET%
echo %YELLOW%Descarcare...%RESET%
curl -L -o %temp%\downloadedFile.7z %downloadUrl%
if %errorlevel% neq 0 (
    echo %RED%Descarcarea a esuat. Te rog verifica cai o conexiune la internet.%RESET%
    pause
    exit /b
)

if not exist "%outputDir%" (
    mkdir "%outputDir%"
    if %errorlevel% neq 0 (
        echo %RED%Nu am reusit sa creez un director. Verifica ai permisiune sa faci asta. Sau ruleaza acest installer ca Administrator.%RESET%
        pause
        exit /b
    )
)

echo %YELLOW%Extrag din zip...%RESET%
"%sevenZipPath%" x %temp%\downloadedFile.7z -o"%outputDir%"
if %errorlevel% neq 0 (
    echo "%RED%Extragerea din zip a esuat. Verifica daca fisierul .7z e downloadat si 7-zip e instalat. Daca nu ai 7-zip il pot instala de aici: https://7-zip.org/%RESET%"
    pause
    exit /b
)

echo %GREEN%Am terminat instalarea de baza pentru ComfyUI.%RESET%
echo %YELLOW%Descarc si instalez extensiile, checkpointurile de stable diffusion, modele de control net si altele%RESET%

cd /d %installDrive%:\ComfyUI_windows_portable\ComfyUI
if not exist "custom_nodes" mkdir "custom_nodes"
cd /d custom_nodes
"C:\Program Files\Git\bin\git.exe" clone -v https://github.com/ltdrdata/ComfyUI-Manager

echo %GREEN%Am descarcat si instalat comfyui manager%RESET%

"C:\Program Files\Git\bin\git.exe" clone https://github.com/cubiq/ComfyUI_IPAdapter_plus.git
"C:\Program Files\Git\bin\git.exe" clone https://github.com/palant/image-resize-comfyui.git
"C:\Program Files\Git\bin\git.exe" clone https://github.com/rgthree/rgthree-comfy.git
"C:\Program Files\Git\bin\git.exe" clone https://github.com/cubiq/ComfyUI_essentials.git

cd /d ..
echo %GREEN%Am descarcat si instalat toate Custom Nodes!%RESET%
::::::::::::::::::::::::::::::::::::::::::

if not exist "models" mkdir "models"
cd /d models
if not exist "vae" mkdir "vae"
if not exist "checkpoints" mkdir "checkpoints"
if not exist "loras" mkdir "loras"
if not exist "controlnet" mkdir "controlnet"
if not exist "upscale_models" mkdir "upscale_models"
if not exist "clip_vision" mkdir "clip_vision"

::::
cd /d vae
curl -L -o sdxl_vae.safetensors https://huggingface.co/stabilityai/sdxl-vae/resolve/main/sdxl_vae.safetensors
cd /d ..
echo %GREEN%Am descarcat si instalat modelele de VAE!%RESET%

::::
cd /d checkpoints
if not exist "sdxl" mkdir "sdxl"
cd /d sdxl
curl -L -o juggernautXL_juggXIByRundiffusion.safetensors "https://civitai.com/api/download/models/782002?type=Model&format=SafeTensor&size=full&fp=fp16"
echo %YELLOW%Am descarcat checkpointul JuggernautXL_juggXIByRundiffusion!%RESET%
curl -L -o realvisxlV50_v50Bakedvae.safetensors "https://civitai.com/api/download/models/789646?type=Model&format=SafeTensor&size=full&fp=fp16"
echo %YELLOW%Am descarcat checkpointul RealVisXL_V50!%RESET%
cd /d ..
cd /d ..
echo %GREEN%Am descarcat si instalat modelele de Checkpoint-uri!%RESET%

::::
cd /d loras
if not exist "sdxl" mkdir "sdxl"
cd /d sdxl
curl -L -o LineAniRedmond-LinearMangaSDXL-V2.safetensors "https://huggingface.co/artificialguybr/LineAniRedmond-LinearMangaSDXL-V2/resolve/main/LineAniRedmondV2-Lineart-LineAniAF.safetensors?download=true"
curl -L -o painting_a3.0.safetensors "https://civitai.com/api/download/models/599869?type=Model&format=SafeTensor"
curl -L -o SketchuraXL_LoRA.safetensors "https://civitai.com/api/download/models/586867?type=Model&format=SafeTensor"
cd /d ..
cd /d ..
echo %GREEN%Am descarcat si instalat modelele de LoRA!%RESET%

::::
cd /d controlnet
if not exist "sdxl" mkdir "sdxl"
cd /d sdxl
curl -L -o control-lora-depth-rank256.safetensors "https://huggingface.co/stabilityai/control-lora/resolve/main/control-LoRAs-rank256/control-lora-depth-rank256.safetensors"
curl -L -o control-lora-canny-rank256.safetensors "https://huggingface.co/stabilityai/control-lora/resolve/main/control-LoRAs-rank256/control-lora-canny-rank256.safetensors"
cd /d ..
cd /d ..
echo %GREEN%Am descarcat si instalat modelele de ControlNet_XL!%RESET%

::::
if not exist "ipadapter" mkdir "ipadapter"
cd /d ipadapter
curl -L -o ip-adapter-plus_sdxl_vit-h.safetensors "https://huggingface.co/h94/IP-Adapter/resolve/main/sdxl_models/ip-adapter-plus_sdxl_vit-h.safetensors"
cd /d ..
echo %GREEN%Am descarcat si instalat modelele de IP Adapter!%RESET%

::::
cd /d clip_vision
curl -L -o CLIP-ViT-H-14-laion2B-s32B-b79K.safetensors "https://huggingface.co/laion/CLIP-ViT-H-14-laion2B-s32B-b79K/resolve/main/open_clip_pytorch_model.safetensors?download=true"


echo %GREEN%Am terminat instalarea pentru COmfyUI!%RESET%
echo %YELLOW%Poti porni COmfyUI in folderul %installDrive%:\ComfyUI_windows_portable dand dublu click pe run_nvidia_gpu.bat.%RESET%
echo %YELLOW%Poti inchide aceasta fereastra. Am terminat!%RESET%
pause
